<?php

$cancerbero_ver = "0.4";

include("include/dbconnect.php");
include_once("include/read_config.php");

$offset = date("Z");

/* IPs Pending */
$query_ips_pending = "SELECT count(*) FROM hosts WHERE priority = 1 and (DATE(FROM_UNIXTIME(d_last_scan)) < date_sub(curdate(),interval $config[delay_scan] day))";
$result_ips_pending = mysql_query($query_ips_pending) or die (mysql_error());
$num_ips_pending = mysql_result($result_ips_pending, 0, 0);
if ($num_ips_pending == 0)
{ 
	$ips_pending = " <span style='font-weight: bold; color: rgb(255, 255, 51);'>0 hosts.</span>";
} else {
	$ips_pending = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>$num_ips_pending hosts.</span>";
}

/* Scanned in last scan interval */
$query_scanned_in_last_scan_interval =  "SELECT count(distinct host_id) FROM scans WHERE (DATE(FROM_UNIXTIME(d)) < date_sub(curdate(),interval $config[delay_scan] day))";
$result_scanned_in_last_scan_interval =  mysql_query($query_scanned_in_last_scan_interval) or die (mysql_error());
$num_ips_scanned_in_last_scan_interval = mysql_result($result_scanned_in_last_scan_interval, 0, 0);
if ($num_ips_scanned_in_last_scan_interval == 0)
{ 
	$ips_scanned_in_last_scan_interval = " <span style='font-weight: bold; color: rgb(255, 255, 51);'>0 hosts.</span>";
} else {
	$ips_scanned_in_last_scan_interval = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>$num_ips_scanned_in_last_scan_interval hosts.</span>";
}

/* Check if cancerbero.pl is running and read the next sweep time */
$result_cancerbero_running = shell_exec('ps -eo cmd | grep cancerbero.pl | grep -vc grep');
$date_next_sweep = date('H:i:s \- D d M y', $program_values[date_next]);
if ($result_cancerbero_running != 0)
{ 
	$cancerbero_process = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>Running</span>";
	$real_next_sweep = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>$date_next_sweep</span>";
} else {
	$cancerbero_process = " <span style='font-weight: bold; color: rgb(255, 255, 51);'>Stopped</span>";
	$real_next_sweep = " <span style='font-weight: bold; color: rgb(255, 255, 51);'>Not Set</span>";
}

/* Check how much instances of sub_nmap.pl are runnig */
$result_sub_nmap_running = shell_exec('ps -eo cmd | grep sub_nmap.pl |grep -vc grep');
if ($result_sub_nmap_running == 0)
{
	$sub_nmap_process = "<span style='font-weight: bold; color: rgb(255, 255, 51);'>0/$config[max_num_scan]</span>";
} else {
	$sub_nmap_process = "<span style='font-weight: bold; color: rgb(0, 153, 0);'>$result_sub_nmap_running /$config[max_num_scan]</span>";
}

/* Read the last scan info */
$date_last_sweep = date('H:i:s \- D d M y', $program_values[date_prev]);
$real_last_sweep = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>$date_last_sweep</span>";
//$real_last_sweep = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>$last_sweep</span>";

/* Get the actual time in epoch Unix */
$actual_time = time ();
//$query_compare_scan =  "select FROM_UNIXTIME($actual_time,'%a %b %H:%i:%s %Y') >= '$next_sweep'";
//$result_compare_scan =  mysql_query($query_compare_scan) or die (mysql_error());
//$result_running_v2 = mysql_result($result_compare_scan, 0, 0);
$result_running_v2 = ($actual_time <= strtotime($date_next_sweep));
if ($result_running_v2){
	$result_running_v2 = " <span style='font-weight: bold; color: rgb(0, 153, 0);'>Running</span>";
} else {
	$result_running_v2 = " <span style='font-weight: bold; color: rgb(255, 255, 51);'>Stopped since $date_next_sweep</span>";
	$real_next_sweep = " <span style='font-weight: bold; color: rgb(255, 255, 51);'>Never</span>";
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
		<meta content="text/html; charset=ISO-8859-1" http-equiv="content-type">
		<title>Cancerbero, the watchdog of the ports</title>
		<script language="JavaScript" type="text/javascript">
		<!--
			function checkform ( form )
			{
				x = 0
				// ** START **
				if (form.hostname.value != "") {
					x++
				}
				if (form.ip.value != "") {
					x++
				}
				if (form.service.value != "") {
					x++
				}
				if (form.mail.value != "") {
					x++
				}
			        if (form.port.value != "") {
               				x++
            			}
				if (x >= 2) {
				alert( "SORRY: You can search only for one field." );
				return false ;
				}
				if (x == 0) {
				alert( "SORRY: You must enter one field." );
				return false ;
				}
			  // ** END **
			  return true ;
			}
		//-->
		</script>
	<LINK REL="SHORTCUT ICON" HREF="utils/cancerbero.ico">
</head>
<body>
<br>
<table style="width: 100%; text-align: left;" bgcolor="#000099" border="1" cellpadding="0" cellspacing="5">
  <tbody>
    <tr>
      <td style="vertical-align: top;">
      <table style="text-align: left; width: 100%;" border="0" cellpadding="0" cellspacing="0">
        <tbody>
          <tr>
            <td colspan="2" rowspan="1" style="background-color: rgb(51, 102, 255); vertical-align: top;">
				<big>
				<big>
				<big>
				<span style="font-weight: bold;"><span style="color: rgb(255, 204, 0);">Cancerbero  </span>
				(The watchdog of the ports)
				</span>
				</big>
				</big>
				</big>
				<br>
            </td>
          </tr>
        </tbody>
      </table>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">
      <table style="text-align: left; width: 100%;" bgcolor="#000099" border="1" cellpadding="0" cellspacing="0">
        <tbody>
          <tr>
            <td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 204, 0);"><b>Config:</b><br>
            <ul>
              <li>Range: <b><?php echo $config[range] ?></b></li>
              <li>Scan Interval: <b><?php echo $config[delay_scan] ?> days.</b></li>
              <li>Sweep Interval: <b><?php echo $config[sweep_time] ?> seconds.</b></li>
              <li>Max Simultaneous Scans: <b><?php echo $config[max_num_scan] ?> hosts.</b></li><br><br>
            </ul>
            </td>
            <td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 153, 102);"><b>Live data:</b><br>
            <ul>
              <li>Cancerbero Engine Status: <?php echo $cancerbero_process ?></li>
              <li>Actual Scans: <?php echo $sub_nmap_process ?></li>
			  <li>Last Sweep: <?php echo $real_last_sweep ?></li>  
			  <li>Running ver 2: <?php echo $result_running_v2 ?></li>  
			  <li>Next Sweep: <?php echo $real_next_sweep ?></li>
              <li><a href= "snapshots.php?snap=8">Alive IPs Pending: <?php echo $ips_pending ?></a></li>
              <li>Scanned in last <?php echo $config[delay_scan] ?> days: <b><?php echo $ips_scanned_in_last_scan_interval ?></b><br><br>
              </li>  
            </ul>
            </td>
          </tr>
          <tr>
            <td colspan="1" rowspan="2" style="vertical-align: top; background-color: rgb(255, 255, 255);"><b>Snapshots:</b><br>
            <ul>
              <li><a href= "snapshots.php?snap=1">10 IPs Last Scanned.</a></li>
              <li><a href= "snapshots.php?snap=2">Todays IPs Scanned.</a></li>
              <li><a href= "snapshots.php?snap=3">Last 24h IPs Scanned.</a></li>
              <li><a href= "snapshots.php?snap=4">Last 72h IPs Scanned.</a></li>
              <li><a href= "snapshots.php?snap=7">NO DNS machines.</a></li>
            </ul>
            </td>
            <td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);"><b>Search:</b> (only by one field)<br>
            <ul>
				<table style="text-align: left;" bgcolor="#000099" border="0" cellpadding="1" cellspacing="1">
					 <tr>
						<td>
							<form action="host_form.php" method="get" onsubmit="return checkform(this);">
								<tr>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<b>IP:</b>
									</td>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<input type="text" name="ip" size="30">
									</td>
								</tr>
						</td>
					</tr>
					
					<tr>
						<td>
							<tr>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<b>Hostname:</b>
									</td>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<input type="text" name="hostname" size="30">
									</td>
								</tr>
						</td>
					</tr>
					
					<tr>
						<td>
							<tr>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<b>Service:</b>
									</td>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<input type="text" name="service" size="30">
									</td>
								</tr>
						</td>
					</tr>
					<tr>
						<td>
							<tr>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<b>Mail:</b>
									</td>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<input type="text" name="mail" size="30">
									</td>
								</tr>
						</td>
					</tr>
				<tr>
						<td>
							<tr>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<b>Port:</b>
									</td>
									<td colspan="1" rowspan="1" style="vertical-align: top; background-color: rgb(255, 255, 255);">
										<input type="text" name="port" size="30">
									</td>
								</tr>
						</td>
					</tr>
					<tr>
						<td colspan="2" rowspan="1" style="text-align: right; vertical-align: top; background-color: rgb(255, 255, 255);">
							<input type="submit" name="search" value="Search">
							<input type="reset" name="reset" value="Reset">
							</form>
						</td>
					</tr>
				</table>
				<br><br>
            </ul>
            </td>
          </tr>
        </tbody>
      </table>
      </td>
    </tr>
  </tbody>
</table>
<br>
<br>
</body>
</html>
